import QtQuick 2.10
import QtQuick.Controls 2.2
import QtQuick.Window 2.10
import QtStudio3D 2.1

Window {
    visible: true
    width: 1280
    height: 480
    title: qsTr("Change Texture Example")

    Studio3D {
        anchors.right: parent.right
        width: 960
        height: 480

        ViewerSettings {
            scaleMode: ViewerSettings.ScaleModeFit
        }

        Presentation {
            id: presentation
            source: "qrc:/presentation/presentation.uia" // Doesn't work, as can't load behavior script (https://bugreports.qt.io/browse/QT3DS-2593)
//            source: "file:/dev/behaviorLoading/presentation/presentation.uia" // Works

            property real timelineTime: 0.0
            property string textString: ""

            Element {
                id: texture
                elementPath: "Scene.Layer.Rectangle.Material.diffusemap"
            }

            Element {
                id: texture2
                elementPath: "Scene.Layer.Rectangle2.Default.diffusemap"
            }

            DataInput {
                name: "controlOne"
                value: presentation.timelineTime
            }

            DataInput {
                name: "controlTwo"
                value: presentation.timelineTime
            }

            DataInput {
                name: "textInput"
                value: presentation.textString
            }

            DataInput {
                name: "runningOrNot"
                value: button.toggle
            }
        }

        onPresentationReady: {
            console.log("ready")
            texture2.setAttribute("sourcepath", "qrc:/pic_01.jpg");
        }
    }

    Button {
        id: button
        property bool toggle: true
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: parent.left
        anchors.leftMargin: 50
        width: 250
        height: 250
        text: "Toggle texture\n and Running"
        onClicked: {
            toggle = !toggle;
            if (toggle) {
                texture.setAttribute("sourcepath", "qrc:/pic_01.jpg");
                presentation.textString += "Longer text\n";

            } else {
                texture.setAttribute("sourcepath", "qrc:/pic_02.jpg");
                presentation.textString += "Text\n";
            }
        }
    }
}
