/*[[
    <Property name="updateRunning" formalName="Running" type="Boolean" default="true" description="Should the data input be updated or not" controllable="True" />
    <Property name="targetDataInput" formalName="Data Input Name" type="String" default="rotateFromBehaviorScript" description="Name of the target data input" />

    <Handler name="start" formalName="Start" category="Running" description="Start running" />
    <Handler name="stop" formalName="Stop" category="Running" description="Stop running" />
]]*/

import QtQuick 2.0
import QtStudio3D.Behavior 1.1

Behavior {
    //External:
    property bool updateRunning
    property string targetDataInput
    //Internal:
    property bool running: true
    property real rotation: 0.0

    function start() {
        running = true;
    }

    function stop() {
        running = false;
    }

    onInitialize: {
        if (updateRunning)
            start();
    }

    onUpdate: {
        if (!running)
            return;

        if (++rotation >= 360.0)
            rotation = 0.0;

        setDataInputValue(targetDataInput, Qt.vector3d(0.0, 0.0, rotation));
    }

    onUpdateRunningChanged: {
        running = updateRunning;
    }
}
